%%

%public
%class ScannerJF
%implements Scanner
%function token
%type Token
%line

%state COMENT

%{

int nivel = 0;

%}

%%

<COMENT> {

[{]   { nivel++; }

[}]   { nivel--; if(nivel == 0) yybegin(YYINITIAL); }

.        { }

[\n\r]   { }

}

<YYINITIAL> {

[ \n\r\t]    { }

[{]   { yybegin(COMENT); nivel++; }

[0-9]+  { return new Token(Token.NUM, yytext(), yyline+1); }

if   { return new Token(Token.IF, yytext(), yyline+1); }
write   { return new Token(Token.WRITE, yytext(), yyline+1); }
repeat   { return new Token(Token.REPEAT, yytext(), yyline+1); }
until   { return new Token(Token.UNTIL, yytext(), yyline+1); }
then   { return new Token(Token.THEN, yytext(), yyline+1); }
end   { return new Token(Token.END, yytext(), yyline+1); }
else   { return new Token(Token.ELSE, yytext(), yyline+1); }
read   { return new Token(Token.READ, yytext(), yyline+1); }
var   { return new Token(Token.VAR, yytext(), yyline+1); }
int   { return new Token(Token.INT, yytext(), yyline+1); }
real   { return new Token(Token.REAL, yytext(), yyline+1); }
bool   { return new Token(Token.BOOL, yytext(), yyline+1); }
procedure   { return new Token(Token.PROCEDURE, yytext(), yyline+1); }
class   { return new Token(Token.CLASS, yytext(), yyline+1); }
begin   { return new Token(Token.BEGIN, yytext(), yyline+1); }
nil   { return new Token(Token.NIL, yytext(), yyline+1); }
new   { return new Token(Token.NEW, yytext(), yyline+1); }
skip   { return new Token(Token.SKIP, yytext(), yyline+1); }
this   { return new Token(Token.THIS, yytext(), yyline+1); }

[a-zA-Z][a-zA-Z0-9_]*  { return new Token(Token.ID, yytext(), yyline+1); }

[:][=]  { return new Token(Token.ATTRIB, yytext(), yyline+1); }

.          { return new Token(yytext().charAt(0), yytext(), yyline+1);  }

}

<<EOF>>    { return new Token(Token.EOF, "<<EOF>>", yyline+1); }
